<?
	session_start();
	// Initializing Engine Classes
	include_once 'engine/strings.php';
	$strings = new Strings();
	include_once 'engine/database.php';
	$database = new Database();	
	include_once 'engine/project.php';
	$project = new Project($database);
	include_once 'engine/user.php';
	$user = new User($database);
	include_once 'engine/form.php';
	$form = new Form($database);
	
	if ($_GET['idProject']) {
		$_SESSION['idProject'] = $_GET['idProject'];
	}	
	
	$arrProject = $project->selectProjects($_SESSION['idProject']);
	if ((count($arrProject) == 0) || (strlen($_SERVER['REQUEST_URI']) <=1)) {
		header("Location: site/home"); exit;
	}
	$arrProject = $arrProject[0];
	
	if ($_SESSION['idUser'] > 0) {
		$arrUser = $user->selectUsers(0, $_SESSION['idUser']);
		$arrUser = $arrUser[0];
		$strJSONScope = json_encode($user->arrUserViewScope($arrUser, $arrProject['idProjectUserViewScope']));
	}

	// Loading strings according to selected language
	$_SESSION['strSiteLanguage'] = ($_GET['language'] ? $_GET['language'] : $arrProject['strLanguageCode']);
	$strings->loadLanguage($_SESSION['strSiteLanguage']);

	setcookie("blnMobile", 1, time() + $strings->intCookieLifeSec); $_COOKIE['blnMobile'] = 1;
?>
<!DOCTYPE html>
<html lang="pt-BR">
<head>
    <title><? echo $arrProject['strName']; ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=0">
    <link rel="shortcut icon" href="<? echo $arrProject['strLogoFileFullPath']; ?>">
    <link type="text/css" rel="stylesheet" href="js/sidemenu/source/jquery.mmenu.css" />
    <link type="text/css" rel="stylesheet" href="js/sidemenu/source/extensions/jquery.mmenu.themes.css" />
	<link type="text/css" rel="stylesheet" href="js/sidemenu/source/extensions/jquery.mmenu.positioning.css" />
    <link href="css/bootstrap.css" rel="stylesheet">
	<link href="css/bootstrap-<? echo $arrProject['strThemeName']; ?>.css" rel="stylesheet">
	<link href="css/bootstrap-responsive.css" rel="stylesheet">
	<link href="css/charisma.css" rel="stylesheet">
	<link href="css/main.css" rel="stylesheet">
	<!-- javascript Libs-->
    <script src="js/jquery-1.11.1.js"></script>
	<script src="js/jquery-ui.js"></script>
	<script src="js/main.js"></script>
	<script src="js/bootstrap-button.js"></script>
	<!-- Google Maps -->
	<script src="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=true&libraries=places,geometry"></script>
    <!-- Side Menu -->
    <script type="text/javascript" src="js/sidemenu/source/jquery.mmenu.js"></script>
    <style>
		.table td {padding:2px;}
		label {display:inline-block}
		li {line-height:35px;padding-left:10px;}
		.navbar{top:0px !important; margin:0px !important;}
		.navbar-inner{top:0px !important; margin:0px !important;}
    </style>
</head>
<body style="margin:0px;padding:0px;font-size:12px;" class="hideSelection">
<span id="alertInfo" class="alert alert-primary" style="display:none;z-index:99999;position:absolute;left:20%;text-align:center;width:50%;"><strong><span id="alertInfoMessage"></span></strong></span>
<? if ((! $arrProject['blnAllowAllView']) && (! ($_SESSION['idUser'] > 0))) { ?>
	<? include 'login.inc'; ?>
<? } else { ?>

<!-- Top Bar -->
<div class="navbar">
    <div class="navbar-inner" style="z-index:9999;width:100%;height:40px;position:fixed;top:0px;min-height: 0px; height: 40px; -webkit-border-radius: 0px; padding: 0px; border: none;border-bottom: 1px solid #FFFFFF;" class="hideSelection">
        <!-- Menu -->
        <a href="#menu" style="margin-top:5px;margin-right:5px;margin-left:7px;text-decoration:none">
            <img src="img/menuWhite.png">
        </a> 
        <!-- Project Name -->
        <img src="<? echo $arrProject['strLogoFileFullPath']; ?>" style="width:36px;height:36px;margin-right:5px;"> 
        <span style="font-weight:bold;font-size:14px;word-break:break-all;line-height:35px;position:absolute;width:71%;overflow:hidden;height:25px">
            <? echo str_ireplace('<br>', ' / ', $arrProject['strName']); ?>
        </span>
    </div>
</div>
<!-- End Top Bar -->

<!-- Main Body -->
<div style="margin-top:40px;text-align:center">
	<!-- Side Menu -->
    <nav id="menu" class="hideSelection" style="background-color:#<? echo $arrProject['strRGBColorDark']; ?>;">
        <ul id="menuContent" style="padding-top:0px;display:none;">
        	<input type="hidden" id="dblLatitude" value="">
        	<input type="hidden" id="dblLongitude" value="">
			<li style="text-align:center;">
                <input type="checkbox" id="blnAllForms" checked="1" onChange="checkAll(this.checked, 'idForm');" style="float: left;position: relative;top: 10px;left: 20px"> 
                <span class="input-prepend input-append" id="spanSearch" style="display:inline">
					<span class="add-on btn-success" style="cursor:pointer;" onClick="recordsLoad();"><i class="icon-search icon-white"></i></span>
	                <input id="strSearch" type="text" style="width:130px" placeholder="<? echo $_SESSION['strIndexSearch']; ?>..." onKeyDown="if(event.keyCode=='13') {recordsLoad();}">
					<span class="add-on" style="cursor:pointer;" onClick="recordsLoadNearests();"><img src="img/myLocation.png" style="width:16px;height:17px;position:relative;top:-1px;"></span>
					<span id="btnUpdate" class="add-on btn-info" onClick="document.getElementById('dblLatitude').value = ''; document.getElementById('dblLongitude').value = ''; recordsLoad();" data-loading-text="..." style="cursor:pointer"><i class="icon-refresh icon-white"></i></span>
                </span>
			</li>
			<?
                $arrForms = $form->selectForms($arrProject['idProject'], 0, '', 1);
                foreach ($arrForms as $i => $arrForm) {
					if ($arrForm['intRecords'] > 0) {
	                    echo '<li style="padding-left:20px;cursor:pointer"><input type="checkbox" id="idForm_' . $i . '" value="' . $arrForm['idForm'] . '" checked> <label for="idForm_' . $i . '"><img src="' . $arrForm['strMarkerFullPath'] . '" style="width:18px;height:18px;margin-right:4px;" class="rounded" align="absmiddle">' . $arrForm['strName'] . ' (' . $arrForm['intRecords'] . ')</label></li>';
					}
                }
            ?>
            <li style="padding-left:20px;">
                <input type="checkbox" id="blnShowStaticMap" <? echo ($_SESSION['blnShowStaticMap'] == 1 ? 'checked' : ''); ?>>
                <label for="blnShowStaticMap"><i class="icon-map-marker icon-white"></i> <? echo $_SESSION['strMobileShowStaticMap']; ?></label>
            </li>
			<? if ($_SESSION['idUser'] > 0) { ?>
            <li style="padding-left:20px;">
                <input type="checkbox" id="blnShowMyRecords" <? echo ($_SESSION['blnShowMyRecords'] == 1 ? 'checked' : ''); ?>> 
                <label for="blnShowMyRecords"><i class="icon-user icon-white"></i> <? echo $_SESSION['strMobileShowMyRecords'] . ' (' . $arrUser['intNumRecords'] . ')'; ?></label>
            </li>
			<li style="padding-left:20px;cursor:pointer">
                <input type="checkbox" id="blnUserPosition" <? echo ($_SESSION['blnUserPosition'] == 1 ? 'checked' : ''); ?> onChange="userPositionActiveUpdate(document.getElementById('imgUserPositionStatus').title == 1 ? false : true, true);">
                <label for="blnUserPosition" id="spanUserPositionStatus"><i class="icon-screenshot icon-white"></i><!-- <img src="img/userRoute.png" style="height:16px" align="absmiddle">--> <? echo $_SESSION['strGlobalEnable'] . ' ' . $_SESSION['strGlobalTracking']; ?></label>
				<img style="height:12px;float:right;position:relative;top:7px;margin-right:10px" id="imgUserPositionStatus" src="" title="<? echo $_SESSION['blnUserPosition']; ?>"> 
			</li>
			<? } ?>
            <li>
	            <a href="index.php?blnMobile=2" target="_self"><img src="img/desktop.png" style="height:16px;" align="absmiddle"><!--<i class="icon-home icon-white"></i>--> <? echo $_SESSION['strMobilePC']; ?></a>
	        </li>
			<? if ($_SESSION['idUser'] > 0) { ?>
            <li style="text-align:center">
                <i class="icon-user icon-white"></i> <? echo $arrUser['strEmailAbbreviated']; ?>
            </li>
            <? } ?>
		</ul>
    </nav>
	<!-- Content -->
	<div id="content" style="text-align:center;"></div>
	<div id="divLoading" style="display:none"><img src="img/loading1.gif"/></div>
</div>
<!-- End Main Body -->
<script>
	function checkAll(blnChecked, str) {
		for (var i=0;i<50;i++) {
			var ck = document.getElementById(str + "_" + i);
			if (! ck) { continue; }
			ck.checked = blnChecked;
		}
	}
	
	function strChecked(str) {
		var ids = '';
		var blnAllChecked = true;
		for (var i=0;i<50;i++) {
			var ck = document.getElementById(str + "_" + i);
			if (! ck) { continue; }
			if (ck.checked) {
				ids += (ids != '' ? ',' : '') + ck.value;
			} else {
				blnAllChecked = false;
			}
		}
		if (blnAllChecked) ids = 'ALL';
		return ids;
	}
	
	var tmUserPosition;
	function userPositionActiveUpdate(blnActivate, blnShowMessage) {
		document.getElementById('imgUserPositionStatus').title = blnActivate ? '1' : '0';
		document.getElementById('imgUserPositionStatus').src = 'img/' + (blnActivate ? 'online.gif' : 'offline.png');
		$.ajax({url: 'ajax.php?chrAction=TUPAU&blnUserPosition=' + document.getElementById('imgUserPositionStatus').title});
		if (blnActivate) {
			tmUserPosition = setInterval("userPositionSubmit();", <? echo $user->intUserPositionSubmitIntervalSecs; ?>*1000);
		} else {
			if (tmUserPosition) { clearInterval(tmUserPosition); }
		}
		if (blnShowMessage) {
			showInfoAlert(blnActivate ? "<? echo $_SESSION['strIndexMenuMyPositionEnableAlert']; ?>" : "<? echo $_SESSION['strIndexMenuMyPositionDisableAlert']; ?>");
		}
	}
	
	function userPositionSubmit() {
		// Try W3C Geolocation (Preferred)
		if(navigator.geolocation) {
			navigator.geolocation.getCurrentPosition(function(position) {
				$.ajax({url: 'ajax.php?chrAction=TUPI' +
							'&idUser=<? echo $_SESSION['idUser']; ?>' + 
							'&dblLatitude=' + position.coords.latitude +
							'&dblLongitude=' + position.coords.longitude
				});
			}, function() {
			});
		}
	}
	
	function recordsLoadNearests() {
		$('#btnUpdate').button('loading');
		if(navigator.geolocation) {
			navigator.geolocation.getCurrentPosition(function(position) {
				document.getElementById('dblLatitude').value = position.coords.latitude;
				document.getElementById('dblLongitude').value = position.coords.longitude;
				recordsLoad(true);
			}, function() {
				$('#btnUpdate').button('reset');
				return strReturn;
			});
		}
		$('#btnUpdate').button('reset');
	}

	var intFrom = 0;
	function recordsLoad(blnClear) {
		$('#btnUpdate').button('loading');
		$("nav#menu").trigger("close.mm");
		document.getElementById('divLoading').style.display = "block";
		var blnClear = blnClear != null ? blnClear : true;
		var strIDForms = strChecked('idForm');
		if (blnClear) {
			intFrom = 0;
			document.getElementById('content').innerHTML = '';
		}
		var result = $.ajax({
			url: 'ajax.php?chrAction=TRL' + 
				'&idProject=<? echo $arrProject['idProject']; ?>' +
				'&idUser=' + (((document.getElementById('blnShowMyRecords') != null) && (document.getElementById('blnShowMyRecords').checked)) ? "<? echo $_SESSION['idUser']; ?>" : "0") +
				'&strIDForms=' + strIDForms +
				'&strSearch=' + document.getElementById('strSearch').value +
				'&blnShowMyRecords=' + (((document.getElementById('blnShowMyRecords') != null) && (document.getElementById('blnShowMyRecords').checked)) ? "1" : "0") +
				'&blnShowStaticMap=' + (document.getElementById('blnShowStaticMap').checked ? "1" : "0") +
				'&dblLat=' + document.getElementById('dblLatitude').value + 
				'&dblLng=' + document.getElementById('dblLongitude').value + 
				'&intFrom=' + intFrom +
				'&intLimit=10' +
				'&strJSONScope=<? echo $_SESSION['strJSONScope']; ?>'
		}).always(function() {
            var response 	= result.responseText;
            var arrResult 	= JSON.parse(response);
			var strNewContent = '';
			for (var i=0;i<arrResult.length;i++) {
				strNewContent +=	'<table class="table table-striped table-bordered bootstrap-datatable datatable" style="border:solid 3px; #000000;margin:1%;width:98%">' + 
									arrResult[i] + 
									'</table>';
			}
			document.getElementById('content').innerHTML += strNewContent;
			document.getElementById('divLoading').style.display="none";
			intFrom = intFrom + 10;
			$('#btnUpdate').button('reset');	
		});
	}
	
	$(window).scroll(function() {
	   if($(window).scrollTop() + $(window).height() == $(document).height()) {
		   recordsLoad(false);
	   }
	});
	
	$(document).ready( function () {
		var $menu = $('nav#menu').mmenu();
		document.getElementById('menuContent').style.display = "block";
		recordsLoad();
		<? if ($_SESSION['idUser'] > 0) { ?>
		userPositionActiveUpdate(<? echo $_SESSION['blnUserPosition'] == 1 ? 'true' : 'false'; ?>, false);
		<? } ?>
	});
</script>
<? } ?>
</body>
</html>